## ros-one-qb-device-control 3.1.2-1jammy.20260221.0049

=== debian/changelog ===
ros-one-qb-device-control (3.1.2-1jammy.20260221.0049) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- qb Support Team <support@qbrobotics.com>  Sat, 21 Feb 2026 00:49:59 +0000

ros-one-qb-device-control (3.1.2-0jammy) jammy; urgency=high



 -- qb Support Team <support@qbrobotics.com>  Fri, 07 Jun 2024 00:00:00 -0000

ros-one-qb-device-control (3.1.1-0jammy) jammy; urgency=high

  * FIX: Lowered CPU resources demand

 -- qb Support Team <support@qbrobotics.com>  Fri, 07 Jun 2024 00:00:00 -0000

ros-one-qb-device-control (3.1.0-0jammy) jammy; urgency=high



 -- qb Support Team <support@qbrobotics.com>  Wed, 26 Jul 2023 00:00:00 -0000

ros-one-qb-device-control (3.0.6-0jammy) jammy; urgency=high

  * MINOR FIX: Changed the name of the package maintainer

 -- qb Support Team <support@qbrobotics.com>  Wed, 26 Apr 2023 00:00:00 -0000

ros-one-qb-device-control (3.0.5-0jammy) jammy; urgency=high

  * MINOR FIX: Changed cmake version required in all packages (current version 3.0.2).
  * Bug fixed when executing the waypoint movement and different controller with different number of controller joints are loaded.

 -- qb Support Team <support@qbrobotics.com>  Wed, 07 Sep 2022 00:00:00 -0000

ros-one-qb-device-control (3.0.4-0jammy) jammy; urgency=high



 -- qb Support Team <support@qbrobotics.com>  Mon, 18 Jul 2022 00:00:00 -0000

ros-one-qb-device-control (3.0.3-0jammy) jammy; urgency=high



 -- qb Support Team <support@qbrobotics.com>  Fri, 15 Jul 2022 00:00:00 -0000

ros-one-qb-device-control (3.0.2-0jammy) jammy; urgency=high



 -- qb Support Team <support@qbrobotics.com>  Thu, 07 Jul 2022 00:00:00 -0000

ros-one-qb-device-control (3.0.1-0jammy) jammy; urgency=high



 -- qb Support Team <support@qbrobotics.com>  Wed, 06 Jul 2022 00:00:00 -0000

ros-one-qb-device-control (3.0.0-0jammy) jammy; urgency=high

  * Created service for Homing SHR2

 -- qb Support Team <support@qbrobotics.com>  Tue, 05 Jul 2022 00:00:00 -0000

ros-one-qb-device-control (2.3.4-0jammy) jammy; urgency=high



 -- qb Support Team <support@qbrobotics.com>  Fri, 08 Apr 2022 00:00:00 -0000

ros-one-qb-device-control (2.3.3-0jammy) jammy; urgency=high



 -- qb Support Team <support@qbrobotics.com>  Fri, 08 Apr 2022 00:00:00 -0000

ros-one-qb-device-control (2.3.2-0jammy) jammy; urgency=high



 -- qb Support Team <support@qbrobotics.com>  Fri, 08 Apr 2022 00:00:00 -0000

ros-one-qb-device-control (2.3.1-0jammy) jammy; urgency=high



 -- qb Support Team <support@qbrobotics.com>  Fri, 08 Apr 2022 00:00:00 -0000

ros-one-qb-device-control (2.3.0-0jammy) jammy; urgency=high



 -- qb Support Team <support@qbrobotics.com>  Fri, 08 Apr 2022 00:00:00 -0000

ros-one-qb-device-control (2.2.1-0jammy) jammy; urgency=high



 -- qb Support Team <support@qbrobotics.com>  Fri, 27 Aug 2021 00:00:00 -0000

ros-one-qb-device-control (2.2.0-0jammy) jammy; urgency=high

  * Fix wait to let the trajectories go steady
  * Add controller startup sync to avoid hardcoded wait
  * Fixed delay for RPi4
  * Refactor control structures initialization
  * Fix control callback first call
  * Refactor Gazebo plugin to prepare for SoftHand simulation
  * Update license

 -- qb Support Team <support@qbrobotics.com>  Fri, 27 Aug 2021 00:00:00 -0000

ros-one-qb-device-control (2.1.1-0jammy) jammy; urgency=high



 -- qb Support Team <support@qbrobotics.com>  Mon, 07 Oct 2019 00:00:00 -0000

ros-one-qb-device-control (2.1.0-0jammy) jammy; urgency=high

  * Improve inheritance for other devices
  * Fix minor style issues

 -- qb Support Team <support@qbrobotics.com>  Tue, 28 May 2019 00:00:00 -0000

ros-one-qb-device-control (2.0.3-0jammy) jammy; urgency=high

  * Update license agreement copyright

 -- qb Support Team <support@qbrobotics.com>  Thu, 09 Aug 2018 00:00:00 -0000

ros-one-qb-device-control (2.0.2-0jammy) jammy; urgency=high



 -- qb Support Team <support@qbrobotics.com>  Tue, 07 Aug 2018 00:00:00 -0000

ros-one-qb-device-control (2.0.1-0jammy) jammy; urgency=high

  * Fix dependencies

 -- qb Support Team <support@qbrobotics.com>  Fri, 01 Jun 2018 00:00:00 -0000

ros-one-qb-device-control (2.0.0-0jammy) jammy; urgency=high

  * Update doxygen documentation
  * Refactor launch files
  * Add method to temporarily change PID parameters
  * Add asynchronous requests for sporadic get/set
  * Add a unique control node
  * Fix minors
  * Fix thread spinning
  * Add basic trajectory builder methods
  * Refactor yaml waypoint trajectory parsing
  * Refactor Actions to match given hardware interfaces
  * Switch to CombinedRobotHW
  * Fix minors
  * Fix waypoints parsing source
  * Add a control loop frequency publisher
  * Refactor launch files and fix controllers spawner
  * Fix destructor calls on ROS shutdown
  * Fix minors

 -- qb Support Team <support@qbrobotics.com>  Wed, 30 May 2018 00:00:00 -0000

ros-one-qb-device-control (1.2.2-0jammy) jammy; urgency=high

  * Add a step (square) wave trajectory generator

 -- qb Support Team <support@qbrobotics.com>  Thu, 30 Nov 2017 00:00:00 -0000

ros-one-qb-device-control (1.1.0-0jammy) jammy; urgency=high

  * Add notes for the future
  * Refactor control timer intialization
  * Add sine wave trajectory generator

 -- qb Support Team <support@qbrobotics.com>  Fri, 24 Nov 2017 00:00:00 -0000

ros-one-qb-device-control (1.0.8-0jammy) jammy; urgency=high

  * Fix C++11 support for cmake version less than 3.1

 -- qb Support Team <support@qbrobotics.com>  Tue, 27 Jun 2017 00:00:00 -0000

ros-one-qb-device-control (1.0.7-0jammy) jammy; urgency=high



 -- qb Support Team <support@qbrobotics.com>  Mon, 26 Jun 2017 00:00:00 -0000

ros-one-qb-device-control (1.0.6-0jammy) jammy; urgency=high

  * Update cmake version to match Kinetic standards

 -- qb Support Team <support@qbrobotics.com>  Fri, 23 Jun 2017 00:00:00 -0000

ros-one-qb-device-control (1.0.5-0jammy) jammy; urgency=high



 -- qb Support Team <support@qbrobotics.com>  Thu, 22 Jun 2017 00:00:00 -0000



## ros-one-qb-device-control 3.1.2-1noble.20251023.0414

=== debian/changelog ===
ros-one-qb-device-control (3.1.2-1noble.20251023.0414) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- qb Support Team <support@qbrobotics.com>  Thu, 23 Oct 2025 04:14:37 +0000

ros-one-qb-device-control (3.1.2-0noble) noble; urgency=high



 -- qb Support Team <support@qbrobotics.com>  Fri, 07 Jun 2024 00:00:00 -0000

ros-one-qb-device-control (3.1.1-0noble) noble; urgency=high

  * FIX: Lowered CPU resources demand

 -- qb Support Team <support@qbrobotics.com>  Fri, 07 Jun 2024 00:00:00 -0000

ros-one-qb-device-control (3.1.0-0noble) noble; urgency=high



 -- qb Support Team <support@qbrobotics.com>  Wed, 26 Jul 2023 00:00:00 -0000

ros-one-qb-device-control (3.0.6-0noble) noble; urgency=high

  * MINOR FIX: Changed the name of the package maintainer

 -- qb Support Team <support@qbrobotics.com>  Wed, 26 Apr 2023 00:00:00 -0000

ros-one-qb-device-control (3.0.5-0noble) noble; urgency=high

  * MINOR FIX: Changed cmake version required in all packages (current version 3.0.2).
  * Bug fixed when executing the waypoint movement and different controller with different number of controller joints are loaded.

 -- qb Support Team <support@qbrobotics.com>  Wed, 07 Sep 2022 00:00:00 -0000

ros-one-qb-device-control (3.0.4-0noble) noble; urgency=high



 -- qb Support Team <support@qbrobotics.com>  Mon, 18 Jul 2022 00:00:00 -0000

ros-one-qb-device-control (3.0.3-0noble) noble; urgency=high



 -- qb Support Team <support@qbrobotics.com>  Fri, 15 Jul 2022 00:00:00 -0000

ros-one-qb-device-control (3.0.2-0noble) noble; urgency=high



 -- qb Support Team <support@qbrobotics.com>  Thu, 07 Jul 2022 00:00:00 -0000

ros-one-qb-device-control (3.0.1-0noble) noble; urgency=high



 -- qb Support Team <support@qbrobotics.com>  Wed, 06 Jul 2022 00:00:00 -0000

ros-one-qb-device-control (3.0.0-0noble) noble; urgency=high

  * Created service for Homing SHR2

 -- qb Support Team <support@qbrobotics.com>  Tue, 05 Jul 2022 00:00:00 -0000

ros-one-qb-device-control (2.3.4-0noble) noble; urgency=high



 -- qb Support Team <support@qbrobotics.com>  Fri, 08 Apr 2022 00:00:00 -0000

ros-one-qb-device-control (2.3.3-0noble) noble; urgency=high



 -- qb Support Team <support@qbrobotics.com>  Fri, 08 Apr 2022 00:00:00 -0000

ros-one-qb-device-control (2.3.2-0noble) noble; urgency=high



 -- qb Support Team <support@qbrobotics.com>  Fri, 08 Apr 2022 00:00:00 -0000

ros-one-qb-device-control (2.3.1-0noble) noble; urgency=high



 -- qb Support Team <support@qbrobotics.com>  Fri, 08 Apr 2022 00:00:00 -0000

ros-one-qb-device-control (2.3.0-0noble) noble; urgency=high



 -- qb Support Team <support@qbrobotics.com>  Fri, 08 Apr 2022 00:00:00 -0000

ros-one-qb-device-control (2.2.1-0noble) noble; urgency=high



 -- qb Support Team <support@qbrobotics.com>  Fri, 27 Aug 2021 00:00:00 -0000

ros-one-qb-device-control (2.2.0-0noble) noble; urgency=high

  * Fix wait to let the trajectories go steady
  * Add controller startup sync to avoid hardcoded wait
  * Fixed delay for RPi4
  * Refactor control structures initialization
  * Fix control callback first call
  * Refactor Gazebo plugin to prepare for SoftHand simulation
  * Update license

 -- qb Support Team <support@qbrobotics.com>  Fri, 27 Aug 2021 00:00:00 -0000

ros-one-qb-device-control (2.1.1-0noble) noble; urgency=high



 -- qb Support Team <support@qbrobotics.com>  Mon, 07 Oct 2019 00:00:00 -0000

ros-one-qb-device-control (2.1.0-0noble) noble; urgency=high

  * Improve inheritance for other devices
  * Fix minor style issues

 -- qb Support Team <support@qbrobotics.com>  Tue, 28 May 2019 00:00:00 -0000

ros-one-qb-device-control (2.0.3-0noble) noble; urgency=high

  * Update license agreement copyright

 -- qb Support Team <support@qbrobotics.com>  Thu, 09 Aug 2018 00:00:00 -0000

ros-one-qb-device-control (2.0.2-0noble) noble; urgency=high



 -- qb Support Team <support@qbrobotics.com>  Tue, 07 Aug 2018 00:00:00 -0000

ros-one-qb-device-control (2.0.1-0noble) noble; urgency=high

  * Fix dependencies

 -- qb Support Team <support@qbrobotics.com>  Fri, 01 Jun 2018 00:00:00 -0000

ros-one-qb-device-control (2.0.0-0noble) noble; urgency=high

  * Update doxygen documentation
  * Refactor launch files
  * Add method to temporarily change PID parameters
  * Add asynchronous requests for sporadic get/set
  * Add a unique control node
  * Fix minors
  * Fix thread spinning
  * Add basic trajectory builder methods
  * Refactor yaml waypoint trajectory parsing
  * Refactor Actions to match given hardware interfaces
  * Switch to CombinedRobotHW
  * Fix minors
  * Fix waypoints parsing source
  * Add a control loop frequency publisher
  * Refactor launch files and fix controllers spawner
  * Fix destructor calls on ROS shutdown
  * Fix minors

 -- qb Support Team <support@qbrobotics.com>  Wed, 30 May 2018 00:00:00 -0000

ros-one-qb-device-control (1.2.2-0noble) noble; urgency=high

  * Add a step (square) wave trajectory generator

 -- qb Support Team <support@qbrobotics.com>  Thu, 30 Nov 2017 00:00:00 -0000

ros-one-qb-device-control (1.1.0-0noble) noble; urgency=high

  * Add notes for the future
  * Refactor control timer intialization
  * Add sine wave trajectory generator

 -- qb Support Team <support@qbrobotics.com>  Fri, 24 Nov 2017 00:00:00 -0000

ros-one-qb-device-control (1.0.8-0noble) noble; urgency=high

  * Fix C++11 support for cmake version less than 3.1

 -- qb Support Team <support@qbrobotics.com>  Tue, 27 Jun 2017 00:00:00 -0000

ros-one-qb-device-control (1.0.7-0noble) noble; urgency=high



 -- qb Support Team <support@qbrobotics.com>  Mon, 26 Jun 2017 00:00:00 -0000

ros-one-qb-device-control (1.0.6-0noble) noble; urgency=high

  * Update cmake version to match Kinetic standards

 -- qb Support Team <support@qbrobotics.com>  Fri, 23 Jun 2017 00:00:00 -0000

ros-one-qb-device-control (1.0.5-0noble) noble; urgency=high



 -- qb Support Team <support@qbrobotics.com>  Thu, 22 Jun 2017 00:00:00 -0000



## ros-one-qb-device-control 3.1.2-1noble.20260221.0123

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.2 FATAL_ERROR)
project(qb_device_control VERSION 3.1.2 LANGUAGES CXX)

# Dependency Settings
find_package(catkin REQUIRED
  COMPONENTS
    roscpp
    actionlib
    combined_robot_hw
    control_msgs
    controller_manager
    qb_device_hardware_interface
    qb_device_utils
)

include_directories(include
  ${catkin_INCLUDE_DIRS}
)

catkin_package(
  INCLUDE_DIRS
    include
  LIBRARIES
    ${PROJECT_NAME}
  CATKIN_DEPENDS
    roscpp
    actionlib
    combined_robot_hw
    control_msgs
    controller_manager
    qb_device_hardware_interface
    qb_device_utils
)

# Build Settings
add_executable(qb_device_default
  src/main.cpp
  src/qb_device_control.cpp
)

target_link_libraries(qb_device_default
  PUBLIC
    ${catkin_LIBRARIES}
)

add_dependencies(qb_device_default
  ${${PROJECT_NAME}_EXPORTED_TARGETS}
  ${catkin_EXPORTED_TARGETS}
)

# Exported libraries
add_library(${PROJECT_NAME}
  src/qb_device_control.cpp
)

target_link_libraries(${PROJECT_NAME}
  PUBLIC
    ${catkin_LIBRARIES}
)

add_dependencies(${PROJECT_NAME}
  ${${PROJECT_NAME}_EXPORTED_TARGETS}
  ${catkin_EXPORTED_TARGETS}
)

# Installation
install(
  TARGETS qb_device_default
  RUNTIME DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/
)

install(
  TARGETS ${PROJECT_NAME}
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_GLOBAL_BIN_DESTINATION}
)

install(
  DIRECTORY
    include/${PROJECT_NAME}/
  DESTINATION
    ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
)

install(
  DIRECTORY
    launch/
  DESTINATION
    ${CATKIN_PACKAGE_SHARE_DESTINATION}/launch
)

=== debian/changelog ===
ros-one-qb-device-control (3.1.2-1noble.20260221.0123) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- qb Support Team <support@qbrobotics.com>  Sat, 21 Feb 2026 01:23:00 +0000

=== debian/control ===
Source: ros-one-qb-device-control
Section: misc
Priority: optional
Maintainer: qb Support Team <support@qbrobotics.com>
Build-Depends: debhelper (>= 9.0.0), ros-one-actionlib, ros-one-catkin, ros-one-combined-robot-hw, ros-one-control-msgs, ros-one-controller-manager, ros-one-qb-device-hardware-interface, ros-one-qb-device-utils, ros-one-roscpp
Homepage: http://wiki.ros.org/qb_device_control
Standards-Version: 3.9.2

Package: ros-one-qb-device-control
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-one-actionlib, ros-one-combined-robot-hw, ros-one-control-msgs, ros-one-controller-manager, ros-one-qb-device-hardware-interface, ros-one-qb-device-utils, ros-one-roscpp
Description: This package contains a device-independent control library for qbrobotics® devices.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/one/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF -DCATKIN_ENABLE_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_configure -- \
		-DFETCHCONTENT_FULLY_DISCONNECTED=OFF \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/one" \
		-DCMAKE_PREFIX_PATH="/opt/ros/one" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-one-qb-device-control//opt/ros/one/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_install
